<template>
    <div>
        <nav>
            <router-link to="/">Home</router-link>
            <router-link to="/about/you">About You</router-link>
            <router-link to="/about/me">About Me</router-link>
            <router-link to="/login">Login</router-link>
        </nav>
        <router-view />
    </div>
</template>

<script>
import Home from './Home';
import Login from './Login';
import About from './About';
import Vue from 'vue';
import VueRouter from 'vue-router';

const router = new VueRouter({
    routes: [
        { path: "/", component: Home },
        { path: "/about/:what", component: About, props: true },
        { path: "/login", component: Login }
    ]
});

router.beforeEach((to, from, next) => {
    if (!to.path.startsWith("/login") && !Vue.prototype.$loginData.userName) {
        next("/login?redirect=" + encodeURI(to.path));
    } else {
        next();
    }
});

export default {
    router
};
</script>

<style>
nav a {
    padding-right: 1rem;
}
</style>
